#include <Ultrasonic.h>
#include <pt.h>

#define BUZZER PIN_PD1
#define RANGE_IN PIN_PC0
#define RANGE_OUT PIN_PC1
#define SWITCH PIN_PB3
#define RED PIN_PB0
#define YELLOW PIN_PB1
#define GREEN PIN_PB2

// นิยามมาโคร PT_DELAY ไว้เพื่อจำลองการหน่วงเวลาแบบมัลติทาสกิ้ง
#define PT_DELAY(pt, ms, ts) \
  ts = millis(); \
  PT_WAIT_WHILE(pt, millis()-ts < (ms));

Ultrasonic Ultrasonic(PIN_PC1, PIN_PC0);

uint32_t dd;
bool check = false;

struct pt pt_taskBuzzer;
struct pt pt_taskSwitch;
struct pt pt_taskWork;

PT_THREAD(taskBuzzer(struct pt* pt))
{
  static uint32_t ts;
 
  PT_BEGIN(pt);
 
  while (1)
  {
    digitalWrite(BUZZER, HIGH);
    PT_DELAY(pt, dd, ts);
    digitalWrite(BUZZER, LOW);
    PT_DELAY(pt, dd, ts);
  }
 
  PT_END(pt);
}

PT_THREAD(taskSwitch(struct pt* pt)) {
  //Serial.println("taskSwitch");
  static uint32_t ts;
 
  PT_BEGIN(pt);
 
  while (1)
  {
    PT_WAIT_UNTIL(pt,digitalRead(SWITCH) == 1);
    PT_DELAY(pt, 10, ts);
    PT_WAIT_UNTIL(pt,digitalRead(SWITCH) == 0);
    PT_DELAY(pt, 10, ts);
    check = !check;
    
    //Serial.println(check);
  }
 
  PT_END(pt);
}

PT_THREAD(taskWork(struct pt* pt)) {
  static uint32_t ts;
 
  PT_BEGIN(pt);
 
  while (1)
  {
    //Serial.println("taskWork");
    if (check) {
      uint32_t r = Ultrasonic.Ranging(CM);
  digitalWrite(GREEN, HIGH);
  digitalWrite(YELLOW, LOW);
  digitalWrite(RED, LOW);
  while (r >= 20) {
    digitalWrite(BUZZER, LOW);
    r = Ultrasonic.Ranging(CM);
    taskSwitch(&pt_taskSwitch);
    if (!check) {
      digitalWrite(YELLOW, LOW);
    digitalWrite(GREEN, LOW);
    digitalWrite(RED, LOW);
    digitalWrite(BUZZER, LOW);
    }
  }
  if (r >= 10) {
    digitalWrite(YELLOW, HIGH);
    digitalWrite(GREEN, LOW);
    digitalWrite(RED, LOW);
    dd = 200;
  }
  else {
    digitalWrite(RED, HIGH);
    digitalWrite(GREEN, LOW);
    digitalWrite(YELLOW, LOW);
    dd = 100;
  }
  taskBuzzer(&pt_taskBuzzer);
  taskSwitch(&pt_taskSwitch);
  if (!check) {
    digitalWrite(YELLOW, LOW);
    digitalWrite(GREEN, LOW);
    digitalWrite(RED, LOW);
    digitalWrite(BUZZER, LOW);
  }
  }
    else {
      break;
    }
  }
 
  PT_END(pt);
}

void setup() {
  // put your setup code here, to run once:
  //Ultrasonic
  pinMode(RANGE_OUT, OUTPUT);
  pinMode(RANGE_IN, INPUT);
  //Serial
  //pinMode(PIN_PD1, OUTPUT);
  //Buzzer
  pinMode(BUZZER, OUTPUT);
  pinMode(SWITCH, INPUT_PULLUP);
  pinMode(RED, OUTPUT);
  pinMode(YELLOW, OUTPUT);
  pinMode(GREEN, OUTPUT);
  //Set Ultrasonic
  digitalWrite(RANGE_IN, HIGH);
  //Serial.begin(9600);
  
  PT_INIT(&pt_taskSwitch);
  PT_INIT(&pt_taskBuzzer);
}
void loop() {
  //Serial.println("xxx");
  taskSwitch(&pt_taskSwitch);
  taskWork(&pt_taskWork);
}
